package com.p3p.serialfiletransfer.packets;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

public class FileStartPacket {
	public FileStartPacket(String filename, String ext, long chunks){
		//mbed filesystem and my packet only support 8.3 filenames
		if(filename.length() > 8){
			filename = filename.substring(0, 7);
		}
		
		if(ext.length() > 3){
			filename = filename.substring(0, 2);
		}
		
		this.filename = filename.getBytes();
		this.ext = ext.getBytes();
		this.chunks = chunks;
	}
	byte type = 1;
	public byte[] filename;
	public byte[] ext;
	public long chunks;
	
	public byte[] encodePacket(){
		ByteBuffer buffer = ByteBuffer.allocate(18);
		buffer.order(ByteOrder.LITTLE_ENDIAN);
		buffer.put(type);
		//fixed length string 8 bytes + null terminator
		buffer.put(filename); 
		if(filename.length < 8){
			buffer.put(new byte[8-filename.length]);
		}
		buffer.put((byte)0);
		//fixed length string 3 bytes + null terminator
		buffer.put(ext);
		if(ext.length < 3){
			buffer.put(new byte[3-ext.length]);
		}
		buffer.put((byte)0);
		
		buffer.putInt((int)((long)(chunks) & 0xFFFFFFFF));
		return buffer.array();
	}
}
